﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;

namespace ExtensionMethods
{
    class Program
    {
        static void Main(string[] args)
        {
            IEnumerable<int> numbers = new[] { 2, 3, 4, 7, 8, 22 };
            var odd = numbers.Where(i => i % 2 == 0).Print().Select(i => i + 1);
            var even = numbers.Select(i => i + 1).Where(i => i % 2 == 0).Print();
            Console.WriteLine(String.Join(", ", odd));
            Console.WriteLine(String.Join(", ", even));


            String original = "My name is Anders";
            String reverse = StringExtensions.ReverseOrdinary(original);
            Console.WriteLine(reverse);

            String rev = original.ReverseExtMet();
            Console.WriteLine(rev);

            var operators = from m in typeof(Enumerable).GetMethods()
                            where m.IsStatic
                            group m by m.Name into queryOperator
                            orderby queryOperator.Key
                            select new
                            {
                                Name = queryOperator.Key,
                                Overloads = queryOperator.Count()
                            };
            Console.WriteLine(String.Join("\n", operators));

        }
    }

    static class Helpers
    {
        public static IEnumerable<T> Print<T>(this IEnumerable<T> data)
        {
            foreach (var d in data)
            {
                Console.Write(d + " ");
                yield return d;
            }
        }
    }

    static class StringExtensions
    {
        // De Smet, page 525
        public static String ReverseOrdinary(String s)
        {
            var chars = s.ToCharArray();
            Array.Reverse(chars);
            return new string(chars);
        }

        public static String ReverseExtMet(this String s)
        {
            var chars = s.ToCharArray();
            Array.Reverse(chars);
            return new string(chars);
        }
    }
}
